% Demo of Hamming and rectangular windowing techniques
% Code adapted from http://mi.eng.cam.ac.uk/~ajr/SA95/node26.html


n = 256; % epoch length
m = 128; % signal length
h = hamming(m); % create hamming window for a signal length m
figure; plot(h)
sr = zeros(size(1:n)); % fill entire viewing area with zeros for raw signal
sh = zeros(size(1:n)); % fill entire viewing area with zeros for hamming tapered signal
f = pi / 3; % define an arbitrary frequency

for i = 1:m ; sr(i) =        sin(f * i) ; end  % create sign wave of frequency f
figure; plot(sr) % plot raw wave
for i = 1:m ; sh(i) = h(i) * sin(f * i) ; end  % apply hamming window to sign wave of frequency f
hold; plot(sh,'r') % plot hamming tapered wave in red
ar=abs(fft(sr)); % FFT of raw signal
ah=abs(fft(sh)); % FFT of hamming tapered signal

% Create plot
figure;
subplot(2,2,1)
plot(sr) % raw signal 

subplot(2,2,2)
plot(sh) % tapered signal

subplot(2,2,3)
plot(ar(1:n/2)) % raw spectrum

subplot(2,2,4)
plot(ah(1:n/2)) % tapered spectrum
